-- 
--     - Dim-Dim  
--

S60Trac = {};

function S60Trac.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function S60Trac:load(xmlFile)
 

	self.charIdAnim = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.animTracLeft#Node"));
	self.clipIndexAnim = getXMLString(xmlFile, "vehicle.animTracLeft#animationClip");	
	
	self.charIdAnim1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.animTracRight#Node"));
	self.clipIndexAnim1 = getXMLString(xmlFile, "vehicle.animTracRight#animationClip");	
	
	self.spedTracLeft = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spedTracLeft#index"));
	self.spedTracRight = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.spedTracRight#index"));

	self.rotatingPartsP = {}
	local i = 0
	while true do
		local baseName = string.format("vehicle.wheelsRotateP.rotatingPartP(%d)", i)
		local index = getXMLString(xmlFile, baseName .. "#index")
		if index == nil then
			break
		end
		local node = Utils.indexToObject(self.components, index)
		if node ~= nil then
			local entry = {}
			entry.node = node
			entry.speedScale = getXMLFloat(xmlFile, baseName .. "#speedScale")
			if entry.speedScale == nil then
				entry.speedScale = 1 / Utils.getNoNil(getXMLFloat(xmlFile, baseName .. "#radius"), 1)
			end
			table.insert(self.rotatingPartsP, entry)
		end
		i = i + 1		
	end
		
	self.rotatingPartsL = {}
	local i = 0
	while true do
		local baseName = string.format("vehicle.wheelsRotateL.rotatingPartL(%d)", i)
		local index = getXMLString(xmlFile, baseName .. "#index")
		if index == nil then
			break
		end
		local node = Utils.indexToObject(self.components, index)
		if node ~= nil then
			local entry = {}
			entry.node = node
			entry.speedScale = getXMLFloat(xmlFile, baseName .. "#speedScale")
			if entry.speedScale == nil then
				entry.speedScale = 1 / Utils.getNoNil(getXMLFloat(xmlFile, baseName .. "#radius"), 1)
			end
			table.insert(self.rotatingPartsL, entry)
		end
		i = i + 1		
	end
end;
	

function S60Trac:getSaveAttributesAndNodes(nodeIdent)

end;

function S60Trac:readStream(streamId, connection)

end;

function S60Trac:writeStream(streamId, connection)

end;

function S60Trac:delete()

end;

function S60Trac:mouseEvent(posX, posY, isDown, isUp, button)
end;

function S60Trac:keyEvent(unicode, sym, modifier, isDown)
end;

function S60Trac:update(dt)

	local newX1, newY1, newZ1 = getWorldTranslation(self.spedTracLeft);
	if self.lastTranslation1 == nil then
		self.lastTranslation1 = {newX1, newY1, newZ1};
	end;
	local dx1, dy1, dz1 = worldDirectionToLocal(self.spedTracLeft, newX1-self.lastTranslation1[1], newY1-self.lastTranslation1[2], newZ1-self.lastTranslation1[3]);
    local movingDirection1 = 0		
	if dz1 < 0.001 then
		movingDirection1 = -1;
	elseif dz1 > 0.001 then
		movingDirection1 = 1;
	end;
	local lastMovedDistance1 = Utils.vector3Length(dx1, dy1, dz1);
    self.lastTranslation1[1] = newX1
    self.lastTranslation1[2] = newY1
    self.lastTranslation1[3] = newZ1

	local newX2, newY2, newZ2 = getWorldTranslation(self.spedTracRight);
	if self.lastTranslation2 == nil then
		self.lastTranslation2 = {newX2, newY2, newZ2};
	end;
	local dx2, dy2, dz2 = worldDirectionToLocal(self.spedTracRight, newX2-self.lastTranslation2[1], newY2-self.lastTranslation2[2], newZ2-self.lastTranslation2[3]);
    local movingDirection2 = 0		
	if dz2 < 0.001 then
		movingDirection2 = -1;
	elseif dz2 > 0.001 then
		movingDirection2 = 1;
	end;
	local lastMovedDistance2 = Utils.vector3Length(dx2, dy2, dz2);	
    self.lastTranslation2[1] = newX2
    self.lastTranslation2[2] = newY2
    self.lastTranslation2[3] = newZ2	
		
	local charId = getAnimCharacterSet(self.charIdAnim);
	local clipIndex = getAnimClipIndex(charId, self.clipIndexAnim);
		
	local charId1 = getAnimCharacterSet(self.charIdAnim1);
	local clipIndex1 = getAnimClipIndex(charId1, self.clipIndexAnim1);		
				
	assignAnimTrackClip(charId , 0, clipIndex);
	setAnimTrackLoopState(charId, 0, true);
	setAnimTrackSpeedScale(charId, 0, 8*lastMovedDistance1*movingDirection1);
	enableAnimTrack(charId, 0);

	assignAnimTrackClip(charId1 , 0, clipIndex1);
	setAnimTrackLoopState(charId1, 0, true);
	setAnimTrackSpeedScale(charId1, 0, 8*lastMovedDistance2*movingDirection2);
	enableAnimTrack(charId1, 0);
	
	for _, v in pairs(self.rotatingPartsP) do
		rotate(v.node, v.speedScale * lastMovedDistance2*movingDirection2, 0, 0)
	end	

	for _, v in pairs(self.rotatingPartsL) do
		rotate(v.node, v.speedScale * lastMovedDistance1*movingDirection1, 0, 0)
	end	  
		
end;

function S60Trac:updateTick()
	
end;

function S60Trac:draw()	

end;

function S60Trac:onDetach()

end;

function S60Trac:onAttach()

end; 

function S60Trac:onLeave()
end;

function S60Trac:onActivate()
end;

function S60Trac:onDeactivate()
end;